<?php
/*
Plugin Name: Simple Plugin Info
Plugin URI: http://www.wordpressplugins.ru/misc/simple-plugin-info.html
Description: Плагин выводит табличку с актуальной информацией о плагинах из репозитория.
Version: 1.00
Author: Flector
Author URI: https://profiles.wordpress.org/flector#content-plugins
*/ 

//блок вывода шорткода plugin (вывод информации о плагине) start 
function plugin_info($atts) {extract($a = shortcode_atts(array("name" => '',"version" => '',"date" => ''), $atts));

	if(!$a['name']) {return;} //если не указан слаг плагина (name), то выходим
    $output = '';
    $purl = plugins_url(); 
	
    //если не найдена информация в кэше, то запрашиваем ее start
	if(!$temp = get_transient('plugin_info-' . $a['name'])) {
        
        $args = (object) array('slug' => $a['name'], 'fields' => array('active_installs' => true));
        $request = array('action' => 'plugin_information', 'timeout' => 15, 'request' => serialize($args));
        $url = 'http://api.wordpress.org/plugins/info/1.0/';
        $response = wp_remote_post($url, array('body' => $request));
        $api = new stdClass();
        $api = unserialize($response['body']);
    
        //все равно кэшируем результат, если репозиторий не отвечает или плагин удален
        //чтобы не дергать репозиторий повторно записываем ошибку в $temp->error
        $temp = new stdClass();
        if( is_wp_error($response) or empty($api) ) {
            $temp->error = 'true';
        } else {
            $temp->error = 'false';
        }

        //записываем в кэш не весь полученный результат, а только нужные поля
        if (!empty($api)) {
            $temp->name = $api->name;
            $temp->requires = $api->requires;
            $temp->active_installs = number_format($api->active_installs, 0, ',', ' ');
            $temp->download_link = $api->download_link;
            $temp->author = mb_substr(strip_tags($api->author), 0, 47);
            $temp->homepage = $api->homepage;
            $temp->downloaded = number_format($api->downloaded, 0, ',', ' ');
            $temp->downloaded2 = $api->downloaded; //число скачиваний без форматирования для использования в russian_number()
            $temp->slug = $api->slug;
            $temp->version = $api->version;
            $temp->last_updated = date('d.m.Y', strtotime($api->last_updated));
        }
    
        set_transient('plugin_info-' . $a['name'], $temp, 24 * HOUR_IN_SECONDS);        
    }
    //если не найдена информация в кэше, то запрашиваем ее end
	
    //выводим информацию о плагине (или сообщение об ошибке, если плагин в репозитории не найден)
	if($temp->error != 'true') {
        
        //название плагина и лого wordpress
        $output .= '<p class="simple-plugin-info"><a href="https://wordpress.org/plugins/'.$temp->slug.'/" rel="nofollow" target="_blank"><img src="'.$purl.'/simple-plugin-info/wp-logo.png" title="Плагин в репозитории WordPress.org" border="0" align="right" alt="" /></a>
        <a href="https://wordpress.org/plugins/'.$temp->slug.'/" rel="nofollow" target="_blank"><strong>'.$temp->name.'</strong></a><br />';
        
        //имя автора с ссылкой на его страницу
        if ($temp->homepage != '') {
            $output .= 'Автор плагина: <a href="'.$temp->homepage.'" rel="nofollow" target="_blank">'.$temp->author.'</a><br />';
        } else {
            $output .= 'Автор плагина: '.$temp->author.'<br />';
        }
        
        //выводим строчку "Рассматриваемая версия xx от xx.xx.xx" (если задано в параметрах шорткода)
        if ($a['version'] != '' and $a['date'] != '') {$output .= 'Рассматриваемая версия: <strong>'.$a['version'].'</strong> от '.$a['date'].'<br />';}
        
        //вывод строчки с текущей версией плагина и совместимостью
        $output .= 'Текущая версия: <strong>'.$temp->version.'</strong> от '.$temp->last_updated.'<br />
        Совместимость с версией WordPress: <strong>'.$temp->requires.'</strong> и выше<br />';
        
        //вывод строчки с числом активных установок плагина
        $output .= 'Активных установок плагина: <strong>'.$temp->active_installs.'+</strong><br />';
        
        //выводим ссылку на скачивание последней версии плагина
        $output .= '<a href="'.$temp->download_link.'" rel="nofollow" title="Скачать плагин '.$temp->name.' версии '.$temp->version.'"><strong>Скачать плагин версии '.$temp->version.'</strong></a> (всего скачено <strong>'.$temp->downloaded.'</strong>'. russian_number($temp->downloaded2, array(' раз', ' раза', ' раз')).')<br />';
       
        $output .= '</p>';
       
        return $output;
    
    } else {
        $output .= '<p class="simple-plugin-info">Информация о плагине в репозитории <strong>wordpress.org</strong> не найдена. Или <strong>wordpress.org</strong> в данный момент недоступен или плагин был временно удален из репозитория (например, из-за найденной критической ошибки в плагине). Попробуйте найти плагин в репозитории <a href="http://wordpress.org/extend/plugins/'.$a['name'].'/" rel="nofollow" target="_blank">самостоятельно</a>.</p>';
        return $output;
    }
}
add_shortcode('plugin', 'plugin_info');

//функция склонения числительных start
function russian_number($number, $titles) {  
    $cases = array (2, 0, 1, 1, 1, 2);  
    return $titles[ ($number%100 > 4 && $number %100 < 20) ? 2 : $cases[min($number%10, 5)] ];  
}  
//функция склонения числительных end

//блок вывода шорткода plugin (вывод информации о плагине) end

//регистрируем и выводим стиль плагина 
function simple_plugin_info_files() {
	$purl = plugins_url();
	
	wp_register_style('simple-plugin-info', $purl . '/simple-plugin-info/simple-plugin-info.css');
	wp_enqueue_style('simple-plugin-info');
}
add_action('wp_enqueue_scripts', 'simple_plugin_info_files');

?>